package Agenda;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "Agenda.idl"
 * <li> <b>IDL Name</b>      ::Agenda::Gerente
 * <li> <b>Repository Id</b> IDL:Agenda/Gerente:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface Gerente {
  ...
};
 * </pre>
 */
public abstract class GerentePOA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, Agenda.GerenteOperations {

  public Agenda.Gerente _this () {
   return Agenda.GerenteHelper.narrow(super._this_object());
  }

  public Agenda.Gerente _this (org.omg.CORBA.ORB orb) {
    return Agenda.GerenteHelper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:Agenda/Gerente:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("insere", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("consulta", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return Agenda.GerentePOA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (Agenda.GerenteOperations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
        java.lang.String c_nome;
        c_nome = _input.read_string();
        java.lang.String c_fone;
        c_fone = _input.read_string();
        _self.insere(c_nome, c_fone);
        _output = _handler.createReply();
        return _output;
      }
      case 1: {
        java.lang.String c_nome;
        c_nome = _input.read_string();
        java.lang.String c_fone;
        c_fone = _input.read_string();
        java.lang.String _result = _self.consulta(c_nome, c_fone);
        _output = _handler.createReply();
        _output.write_string((java.lang.String)_result);
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
