package Agenda;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "Agenda.idl"
 * <li> <b>IDL Name</b>      ::Agenda::Cliente
 * <li> <b>Repository Id</b> IDL:Agenda/Cliente:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface Cliente {
  ...
};
 * </pre>
 */
public class ClientePOATie extends ClientePOA {
  private Agenda.ClienteOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public ClientePOATie (final Agenda.ClienteOperations _delegate) {
    this._delegate = _delegate;
  }

  public ClientePOATie (final Agenda.ClienteOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public Agenda.ClienteOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final Agenda.ClienteOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

}
